// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep

#include "Utilities/LinearAlgebra/Type.hpp"

#include "OperatorInstances/HyperelasticLaws/CiarletGeymonat.hpp"

#include "Test/Operators/VariationalInstances/HyperelasticOperator/ExpectedResults.hpp"
#include "Test/Operators/VariationalInstances/HyperelasticOperator/ModelSettings.hpp"

// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

namespace MoReFEM::TestNS::HyperelasticOperatorNS
{


    template<>
    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP1P1<HyperelasticLawNS::CiarletGeymonat<time_manager_type>>()
    {
        return expected_results_type<LinearAlgebraNS::type::matrix>{ { 3.1217090685513039e+05,
                                                                       -3.3853282924275343e+04,
                                                                       -1.7368938260204846e+05,
                                                                       -4.5434638101778150e+05,
                                                                       5.2255044770341337e+05,
                                                                       3.0953072377127153e+05,
                                                                       -1.2174762528102101e+04,
                                                                       -6.7229064374547126e+05,
                                                                       4.3166649850710673e+05,
                                                                       1.5435023669075326e+05,
                                                                       1.8359347896633283e+05,
                                                                       -5.6750783967632975e+05 },
                                                                     { -3.3853282924274725e+04,
                                                                       1.4385638257357033e+05,
                                                                       -9.0810132131849154e+04,
                                                                       -3.2258166769936541e+05,
                                                                       -1.6870767319768760e+05,
                                                                       2.6098051140776899e+05,
                                                                       5.2885965319517429e+05,
                                                                       -8.3481261552662007e+04,
                                                                       -1.5930392834597424e+04,
                                                                       -1.7242470257153412e+05,
                                                                       1.0833255217677934e+05,
                                                                       -1.5423998644132249e+05 },
                                                                     { -1.7368938260204828e+05,
                                                                       -9.0810132131848775e+04,
                                                                       1.9825720843998215e+05,
                                                                       1.7642226053204600e+05,
                                                                       -9.5012248305740359e+04,
                                                                       -2.6599397969118395e+05,
                                                                       -2.8034444274426944e+05,
                                                                       2.0694119272750607e+05,
                                                                       -1.2243880854213117e+05,
                                                                       2.7761156481427158e+05,
                                                                       -2.1118812289916998e+04,
                                                                       1.9017557979333296e+05 },
                                                                     { -4.5434638101778040e+05,
                                                                       -3.2258166769936384e+05,
                                                                       1.7642226053204687e+05,
                                                                       7.5629201860725158e+05,
                                                                       -2.7362799789453665e+05,
                                                                       -3.8600137181572866e+05,
                                                                       -1.1885537784570358e+05,
                                                                       9.3899281729240855e+05,
                                                                       -5.7104552303612535e+05,
                                                                       -1.8309025974376764e+05,
                                                                       -3.4278315169850830e+05,
                                                                       7.8062463431980740e+05 },
                                                                     { 5.2255044770341326e+05,
                                                                       -1.6870767319768807e+05,
                                                                       -9.5012248305740999e+04,
                                                                       -2.7362799789453624e+05,
                                                                       3.6567013221694820e+05,
                                                                       -1.0003420108132465e+05,
                                                                       -5.6775857535822142e+05,
                                                                       -1.4854472065770821e+05,
                                                                       5.0141866213587031e+05,
                                                                       3.1883612554934435e+05,
                                                                       -4.8417738361551899e+04,
                                                                       -3.0637221274880489e+05 },
                                                                     { 3.0953072377127130e+05,
                                                                       2.6098051140776885e+05,
                                                                       -2.6599397969118430e+05,
                                                                       -3.8600137181572849e+05,
                                                                       -1.0003420108132482e+05,
                                                                       4.3686992632135056e+05,
                                                                       4.6337927081907343e+05,
                                                                       -5.4979346678880753e+05,
                                                                       5.4027622069957542e+04,
                                                                       -3.8690862277461670e+05,
                                                                       3.8884715646236372e+05,
                                                                       -2.2490356870012404e+05 },
                                                                     { -1.2174762528102945e+04,
                                                                       5.2885965319517301e+05,
                                                                       -2.8034444274426997e+05,
                                                                       -1.1885537784570297e+05,
                                                                       -5.6775857535822084e+05,
                                                                       4.6337927081907354e+05,
                                                                       2.7772904735862720e+05,
                                                                       -1.5706200769651009e+05,
                                                                       -9.9566859924574965e+04,
                                                                       -1.4669890698482128e+05,
                                                                       1.9596092985955800e+05,
                                                                       -8.3467968150228684e+04 },
                                                                     { -6.7229064374547137e+05,
                                                                       -8.3481261552662123e+04,
                                                                       2.0694119272750663e+05,
                                                                       9.3899281729240960e+05,
                                                                       -1.4854472065770821e+05,
                                                                       -5.4979346678880765e+05,
                                                                       -1.5706200769651044e+05,
                                                                       4.7744519345819228e+05,
                                                                       -2.7567797076382220e+05,
                                                                       -1.0964016585042783e+05,
                                                                       -2.4541921124782192e+05,
                                                                       6.1853024482512323e+05 },
                                                                     { 4.3166649850710662e+05,
                                                                       -1.5930392834598159e+04,
                                                                       -1.2243880854213101e+05,
                                                                       -5.7104552303612512e+05,
                                                                       5.0141866213587101e+05,
                                                                       5.4027622069957542e+04,
                                                                       -9.9566859924575168e+04,
                                                                       -2.7567797076382180e+05,
                                                                       3.3696767886216077e+05,
                                                                       2.3894588445359372e+05,
                                                                       -2.0981029853745081e+05,
                                                                       -2.6855649238998728e+05 },
                                                                     { 1.5435023669075296e+05,
                                                                       -1.7242470257153397e+05,
                                                                       2.7761156481427158e+05,
                                                                       -1.8309025974376718e+05,
                                                                       3.1883612554934417e+05,
                                                                       -3.8690862277461670e+05,
                                                                       -1.4669890698482140e+05,
                                                                       -1.0964016585042764e+05,
                                                                       2.3894588445359378e+05,
                                                                       1.7543893003783567e+05,
                                                                       -3.6771257127382516e+04,
                                                                       -1.2964882649324884e+05 },
                                                                     { 1.8359347896633280e+05,
                                                                       1.0833255217677986e+05,
                                                                       -2.1118812289916616e+04,
                                                                       -3.4278315169850795e+05,
                                                                       -4.8417738361552343e+04,
                                                                       3.8884715646236355e+05,
                                                                       1.9596092985955754e+05,
                                                                       -2.4541921124782195e+05,
                                                                       -2.0981029853745108e+05,
                                                                       -3.6771257127382472e+04,
                                                                       1.8550439743259447e+05,
                                                                       -1.5791804563499585e+05 },
                                                                     { -5.6750783967632940e+05,
                                                                       -1.5423998644132187e+05,
                                                                       1.9017557979333308e+05,
                                                                       7.8062463431980740e+05,
                                                                       -3.0637221274880564e+05,
                                                                       -2.2490356870012416e+05,
                                                                       -8.3467968150228975e+04,
                                                                       6.1853024482512323e+05,
                                                                       -2.6855649238998728e+05,
                                                                       -1.2964882649324877e+05,
                                                                       -1.5791804563499571e+05,
                                                                       3.0328448129677842e+05 } };
    }


    template<>
    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP1P1<HyperelasticLawNS::CiarletGeymonat<time_manager_type>>()
    {
        return expected_results_type<LinearAlgebraNS::type::vector>{
            -916961.9543119553,  -289344.2116201838,  338273.53107158747,  1294354.3854437985,
            -427657.16994497296, -607781.0492594626,  -208308.57392077643, 1124373.187922917,
            -626720.4023819587,  -169083.85721106746, -407371.8063577601,  896227.9205698341
        };
    }


} // namespace MoReFEM::TestNS::HyperelasticOperatorNS

// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
